diff -Naur -X diff_ignore rsync-3.0.6_base/xattrs.c rsync/xattrs.c
--- rsync-3.0.6_base/xattrs.c	2009-06-18 17:30:42.000000000 -0400
+++ rsync/xattrs.c	2019-01-14 13:38:36.000000000 -0500
@@ -22,6 +22,8 @@
 #include "rsync.h"
 #include "ifuncs.h"
 #include "lib/sysxattrs.h"
+// For _PATH_RSRCFORKSPEC
+#include <sys/paths.h>
 
 #ifdef SUPPORT_XATTRS
 
@@ -32,7 +34,12 @@
 extern int read_only;
 extern int list_only;
 extern int preserve_xattrs;
+extern int preserve_hfs_compression;
+extern int fs_supports_native_xattrs;
+extern uid_t receiver_uid;
+extern long pc_xattr_max_size;
 extern int checksum_seed;
+extern struct stats stats;
 
 #define RSYNC_XAL_INITIAL 5
 #define RSYNC_XAL_LIST_INITIAL 100
@@ -47,6 +54,7 @@
 #define XSTATE_ABBREV	1
 #define XSTATE_DONE	2
 #define XSTATE_TODO	3
+#define XSTATE_DECMPFS	4
 
 #define USER_PREFIX "user."
 #define UPRE_LEN ((int)sizeof USER_PREFIX - 1)
@@ -69,6 +77,8 @@
 #define XDEF_ACL_SUFFIX "dacl"
 #define XDEF_ACL_ATTR RSYNC_PREFIX "%" XDEF_ACL_SUFFIX
 
+#define FAST_RESOURCE_FORKS 1
+
 typedef struct {
 	char *datum, *name;
 	size_t datum_len, name_len;
@@ -89,7 +99,6 @@
 {
 	size_t i;
 	rsync_xa *rxas = xalp->items;
-
 	for (i = 0; i < xalp->count; i++) {
 		free(rxas[i].datum);
 		/*free(rxas[i].name);*/
@@ -117,7 +126,17 @@
 {
 	ssize_t list_len;
 	double arg;
-
+	
+	/* Determine if this is a ._ AppleDouble file */
+	const char *f;
+	if ((f = strrchr(fname, '/')) != NULL)
+		++f;
+	else
+		f = fname;
+	
+	if ( f[0] == '.' && f[1] == '_')
+		return 0;
+	
 	if (!namebuf) {
 		namebuf_len = 1024;
 		namebuf = new_array(char, namebuf_len);
@@ -131,14 +150,14 @@
 		if (list_len >= 0) {
 			if ((size_t)list_len <= namebuf_len)
 				break;
-		} else if (errno == ENOTSUP)
+		} else if (errno == ENOTSUP || errno == ENOENT || errno == EINVAL || (errno == EACCES && !am_root))
 			return 0;
 		else if (errno != ERANGE) {
 			arg = (double)namebuf_len;
 		  got_error:
 			rsyserr(FERROR_XFER, errno,
-				"get_xattr_names: llistxattr(\"%s\",%.0f) failed",
-				fname, arg);
+				"[%s]get_xattr_names: llistxattr(%s,%.0f) failed",
+				who_am_i(), full_fname(fname), arg);
 			return -1;
 		}
 		list_len = sys_llistxattr(fname, NULL, 0);
@@ -163,18 +182,19 @@
 static char *get_xattr_data(const char *fname, const char *name, size_t *len_ptr,
 			    int no_missing_error)
 {
-	size_t datum_len = sys_lgetxattr(fname, name, NULL, 0);
-	size_t extra_len = *len_ptr;
+	ssize_t datum_len = sys_lgetxattr(fname, name, NULL, 0);
+	ssize_t extra_len = *len_ptr;
 	char *ptr;
 
 	*len_ptr = datum_len;
 
-	if (datum_len == (size_t)-1) {
-		if (errno == ENOTSUP || no_missing_error)
+	if (datum_len == -1) {
+		if (errno == ENOTSUP || errno == ENOATTR || errno == ENOENT || no_missing_error)
 			return NULL;
-		rsyserr(FERROR_XFER, errno,
-			"get_xattr_data: lgetxattr(\"%s\",\"%s\",0) failed",
-			fname, name);
+		if ((receiver_uid == 0 && strcmp(name, KAUTH_FILESEC_XATTR) != 0) || (errno != EPERM && errno != EACCES))
+			rsyserr(FERROR_XFER, errno,
+				"[%s]get_xattr_data: lgetxattr(%s,\"%s\",0) failed",
+				who_am_i(), full_fname(fname), name);
 		return NULL;
 	}
 
@@ -182,21 +202,30 @@
 		extra_len = 1; /* request non-zero amount of memory */
 	if (datum_len + extra_len < datum_len)
 		overflow_exit("get_xattr_data");
-	if (!(ptr = new_array(char, datum_len + extra_len)))
-		out_of_memory("get_xattr_data");
+	if (!(ptr = new_array(char, datum_len + extra_len))) {
+		fprintf(stderr, "get_xattr_data: Tried to allocate %zd bytes for the %s xattr on %s. This extended attribute was not copied.\n", datum_len, name, full_fname(fname));
+		if (strcmp(name, XATTR_RESOURCEFORK_NAME) == 0)
+			return NULL;
+		else
+			out_of_memory("get_xattr_data");
+	}
 
 	if (datum_len) {
-		size_t len = sys_lgetxattr(fname, name, ptr, datum_len);
+		ssize_t len = sys_lgetxattr(fname, name, ptr, datum_len);
+		if (len == -1 && (errno == ENOENT || errno == ENOATTR)) // Potential race condition if source file is deleted after initial successful sys_lgetxattr() call
+			return NULL;
 		if (len != datum_len) {
-			if (len == (size_t)-1) {
+			if (len == -1) {
 				rsyserr(FERROR_XFER, errno,
-				    "get_xattr_data: lgetxattr(\"%s\",\"%s\",%ld)"
-				    " failed", fname, name, (long)datum_len);
+				    "[%s]get_xattr_data: lgetxattr(%s,\"%s\",%zd)"
+				    " failed", who_am_i(), full_fname(fname), name, datum_len);
 			} else {
-				rprintf(FERROR_XFER,
-				    "get_xattr_data: lgetxattr(\"%s\",\"%s\",%ld)"
-				    " returned %ld\n", fname, name,
-				    (long)datum_len, (long)len);
+				// Filter out garbage from the buggy Synology DiskStation file sharing service
+				if (strstr(name, "APIC_") == NULL && strstr(name, "_DSAUDIO") == NULL && strstr(name, "_JPEGTN") == NULL)
+					rprintf(FERROR_XFER,
+							"rsync: [%s]get_xattr_data: lgetxattr(%s,\"%s\",%zd)"
+							" returned %zd (%d)\n", who_am_i(), full_fname(fname), name,
+							datum_len, len, errno);
 			}
 			free(ptr);
 			return NULL;
@@ -206,7 +235,7 @@
 	return ptr;
 }
 
-static int rsync_xal_get(const char *fname, item_list *xalp)
+static int rsync_xal_get(const char *fname, stat_x *sxp)
 {
 	ssize_t list_len, name_len;
 	size_t datum_len, name_offset;
@@ -216,6 +245,12 @@
 #endif
 	rsync_xa *rxa;
 	int count;
+	item_list *xalp;
+	
+	xalp = sxp->xattr;
+
+//	struct timeval start;
+//	gettimeofday(&start, NULL);
 
 	/* This puts the name list into the "namebuf" buffer. */
 	if ((list_len = get_xattr_names(fname)) < 0)
@@ -244,23 +279,80 @@
 				continue;
 		}
 
-		datum_len = name_len; /* Pass extra size to get_xattr_data() */
-		if (!(ptr = get_xattr_data(fname, name, &datum_len, 0)))
-			return -1;
-
-		if (datum_len > MAX_FULL_DATUM) {
-			/* For large datums, we store a flag and a checksum. */
-			name_offset = 1 + MAX_DIGEST_LEN;
-			sum_init(checksum_seed);
-			sum_update(ptr, datum_len);
-			free(ptr);
-
+//		datum_len = name_len; /* Pass extra size to get_xattr_data() */
+//		if (!(ptr = get_xattr_data(fname, name, &datum_len, 0)))
+//			return -1;
+//
+		//if (strcmp(name, XATTR_DECMPFS_NAME) == 0 || strcmp(name, XATTR_RESOURCEFORK_NAME) == 0) {
+		if (strcmp(name, XATTR_DECMPFS_NAME) == 0 || (preserve_hfs_compression && sxp->st.st_flags & UF_COMPRESSED && strcmp(name, XATTR_RESOURCEFORK_NAME) == 0)) {
+			if (verbose)
+				fprintf(stderr, "DEBUG: xal_get[%s]: Special decmpfs handling, name: %s, f: %d |%s\n", who_am_i(), name, sxp->st.st_flags, fname);
+
+			// It's too expensive to calculate checksums for every xattr containing decmpfs payload.
+			// Instead, we'll copy these every time as long as the file modification 
+			// date has changed. This seems to be inline with Apple's intentions
+			// for how fs compression will be used
+			datum_len = 1;
+			name_offset = datum_len;
 			if (!(ptr = new_array(char, name_offset + name_len)))
 				out_of_memory("rsync_xal_get");
-			*ptr = XSTATE_ABBREV;
-			sum_end(ptr + 1);
-		} else
-			name_offset = datum_len;
+			*ptr = XSTATE_DECMPFS;
+		} else {
+			if (verbose > 1)
+				fprintf(stderr, "DEBUG: xal_get[%s]: name: %s, f: %d |%s\n", who_am_i(), name, sxp->st.st_flags, fname);
+		
+			datum_len = name_len; /* Pass extra size to get_xattr_data() */
+			if (!(ptr = get_xattr_data(fname, name, &datum_len, 0))) {
+				//return -1;
+				if (strcmp(name, "com.apple.FinderInfo") == 0)
+					fprintf(stderr, "DEBUG: xal_get[%s]: get_xattr_data(%s, %s) failed, continuing anyway\n", who_am_i(), full_fname(fname), name);
+				continue; // One unreadable xattr doesn't mean they will all be unreadable
+			}
+			
+			if (datum_len > MAX_FULL_DATUM) {
+				/* For large datums, we store a flag and a checksum. */
+				name_offset = 1 + MAX_DIGEST_LEN;
+#ifdef FAST_RESOURCE_FORKS
+				if (strcmp(name, XATTR_RESOURCEFORK_NAME) == 0) {
+					// Rather than calculate a checksum of resource forks, we're just going to store the first MAX_DIGEST_LEN bytes for comparison
+					char buf[MAX_DIGEST_LEN];
+					memcpy(buf, ptr, MAX_DIGEST_LEN);
+
+					free(ptr);
+
+					if (!(ptr = new_array(char, name_offset + name_len)))
+						out_of_memory("rsync_xal_get");
+					*ptr = XSTATE_ABBREV;
+					memcpy(ptr + 1, buf, MAX_DIGEST_LEN);
+				} else {
+#endif
+				if (verbose > 1)
+					fprintf(stderr, "DEBUG: xal_get[%s]: abbreviating, name: %s |%s\n", who_am_i(), name, fname);
+
+				sum_init(checksum_seed);
+				sum_update(ptr, datum_len);
+				free(ptr);
+
+				if (!(ptr = new_array(char, name_offset + name_len)))
+					out_of_memory("rsync_xal_get");
+				*ptr = XSTATE_ABBREV;
+				sum_end(ptr + 1);
+#ifdef FAST_RESOURCE_FORKS
+				}
+#endif
+				// Update stats on sender side -- for total_size, we only add the size of xattrs that will be abbreviated. 
+				// We can't include non-abbreviated xattrs in total_transfer_size because the sender doesn't know if they're actually used
+				// Therefore, it's best to just leave unabbreviated xattrs out of the stats so that total_transfer_size matches up with total_size
+				// Abbreviated values can cause trouble too, e.g. if they're attached to hard-linked files. These xattrs get transferred for each instance of the file (and that should be fixed!). A lame workaround for now is to not include the size of xattrs attached to hard linked files in total_size or total_transferred_size
+				stats.total_size += (unsigned long long)datum_len;
+				if (verbose && !am_generator)
+					fprintf(stderr, "DEBUG: [%s] XALGET: stats.total_size |%s|+%lu\n", who_am_i(), full_fname(fname), (unsigned long)datum_len);
+			} else
+				name_offset = datum_len;
+		}
+
+		if (verbose)
+			fprintf(stderr, "DEBUG: xal_get[%s]: name: %s, type: %s, len: %lu |%s\n", who_am_i(), name, (datum_len > MAX_FULL_DATUM || (datum_len == 1 && ptr[0] == XSTATE_ABBREV)) ? "abbrev" : "reg", (unsigned long)datum_len, fname);
 
 		rxa = EXPAND_ITEM_LIST(xalp, rsync_xa, RSYNC_XAL_INITIAL);
 		rxa->name = ptr + name_offset;
@@ -268,6 +360,9 @@
 		rxa->datum = ptr;
 		rxa->name_len = name_len;
 		rxa->datum_len = datum_len;
+
+		// Update stats on sender side
+		stats.num_xattrs++;
 	}
 	count = xalp->count;
 	rxa = xalp->items;
@@ -275,6 +370,7 @@
 		qsort(rxa, count, sizeof (rsync_xa), rsync_xal_compare_names);
 	for (rxa += count-1; count; count--, rxa--)
 		rxa->num = count;
+
 	return 0;
 }
 
@@ -287,7 +383,7 @@
 	if (IS_SPECIAL(sxp->st.st_mode) || IS_DEVICE(sxp->st.st_mode))
 		return 0;
 
-	if (rsync_xal_get(fname, sxp->xattr) < 0) {
+	if (rsync_xal_get(fname, sxp) < 0) {
 		free_xattr(sxp);
 		return -1;
 	}
@@ -303,6 +399,9 @@
 	int user_only = am_root <= 0;
 #endif
 
+	if (verbose)
+		fprintf(stderr, "copy_xattrs: %s\n", dest);
+
 	/* This puts the name list into the "namebuf" buffer. */
 	if ((list_len = get_xattr_names(source)) < 0)
 		return -1;
@@ -322,11 +421,15 @@
 		datum_len = 0;
 		if (!(ptr = get_xattr_data(source, name, &datum_len, 0)))
 			return -1;
+
+		if (verbose)
+			fprintf(stderr, "DEBUG: %s, datum: %p, datum_len: %lu\n", name, ptr, (unsigned long)datum_len);
+
 		if (sys_lsetxattr(dest, name, ptr, datum_len) < 0) {
 			int save_errno = errno ? errno : EINVAL;
 			rsyserr(FERROR_XFER, errno,
-				"rsync_xal_set: lsetxattr(\"%s\",\"%s\") failed",
-				dest, name);
+				"copy_xattrs: lsetxattr(%s,\"%s\") failed",
+				full_fname(dest), name);
 			errno = save_errno;
 			return -1;
 		}
@@ -336,11 +439,11 @@
 	return 0;
 }
 
+// /*
 static int find_matching_xattr(item_list *xalp)
 {
 	size_t i, j;
 	item_list *lst = rsync_xal_l.items;
-
 	for (i = 0; i < rsync_xal_l.count; i++) {
 		rsync_xa *rxas1 = lst[i].items;
 		rsync_xa *rxas2 = xalp->items;
@@ -383,13 +486,16 @@
 	(void)EXPAND_ITEM_LIST(new_lst, rsync_xa, xalp->count);
 	memcpy(new_lst->items, xalp->items, xalp->count * sizeof (rsync_xa));
 	new_lst->count = xalp->count;
-	xalp->count = 0;
+	xalp->count = 0; // Why?
 }
+// /*
 
 /* Send the make_xattr()-generated xattr list for this flist entry. */
 int send_xattr(stat_x *sxp, int f)
 {
-	int ndx = find_matching_xattr(sxp->xattr);
+	// find_matching_xattr is a waste of cycles for MOSX clients
+	//int ndx = find_matching_xattr(sxp->xattr);
+	int ndx = -1;
 
 	/* Send 0 (-1 + 1) to indicate that literal xattr data follows. */
 	write_varint(f, ndx + 1);
@@ -416,6 +522,9 @@
 				name_len += UPRE_LEN;
 			}
 #endif
+			if (verbose)
+				fprintf(stderr, "DEBUG: send_xattr: name: %s, type: %d, len: %lu, ndx: %ld\n", name, rxa->datum[0], (unsigned long)rxa->datum_len, rsync_xal_l.count);
+
 			write_varint(f, name_len);
 			write_varint(f, rxa->datum_len);
 #ifndef HAVE_LINUX_XATTRS
@@ -429,10 +538,17 @@
 				write_buf(f, rxa->datum + 1, MAX_DIGEST_LEN);
 			else
 				write_buf(f, rxa->datum, rxa->datum_len);
+
+			stats.num_xattrs++;
 		}
 		ndx = rsync_xal_l.count; /* pre-incremented count */
 		rsync_xal_store(sxp->xattr); /* adds item to rsync_xal_l */
-	}
+
+		if (verbose && ndx == rsync_xal_l.count)
+			// xal_cnt should always be xndx+1
+			fprintf(stderr, "DEBUG: send_xattr[%s]: rsync_xal_l.count was not incremented!\n", who_am_i());
+		//ndx = rsync_xal_l.count - 1;
+}
 
 	return ndx;
 }
@@ -447,6 +563,15 @@
 	int snd_cnt, rec_cnt;
 	int cmp, same, xattrs_equal = 1;
 
+
+	// If the file is marked compressed, we'll only compare xattrs if the mod date of the files are different
+	if (preserve_hfs_compression && F_FFLAGS(file) & UF_COMPRESSED && sxp != NULL && sxp->st.st_flags & UF_COMPRESSED) {
+		if (verbose)
+			fprintf(stderr, "DEBUG: xattr_diff[compressed]: Source[fl:%s, sz:%.0f, t:%ld], Dest[fl:%s, t:%ld] diff: %s, ndx: %d |%s\n", F_FFLAGS(file) & UF_COMPRESSED ? "Y" : "N", (double)F_LENGTH(file), file->modtime, (sxp != NULL && sxp->st.st_flags & UF_COMPRESSED) ? "Y" : "N", (sxp != NULL && sxp->st.st_mtime) ? sxp->st.st_mtime : 0, (sxp != NULL && cmp_time(sxp->st.st_mtime, file->modtime) == 0) ? "N" : "Y", F_XATTR(file), f_name(file, NULL));
+		if (cmp_time(sxp->st.st_mtime, file->modtime) == 0)
+			return 0;
+	}
+
 	if (sxp && XATTR_READY(*sxp)) {
 		rec_rxa = sxp->xattr->items;
 		rec_cnt = sxp->xattr->count;
@@ -463,6 +588,9 @@
 	snd_rxa = lst->items;
 	snd_cnt = lst->count;
 
+	if (verbose)
+		fprintf(stderr, "DEBUG: xattr_diff: s:%d, r:%d, ndx: %d |%s\n", snd_cnt, rec_cnt, F_XATTR(file), f_name(file, NULL));
+
 	/* If the count of the sender's xattrs is different from our
 	 * (receiver's) xattrs, the lists are not the same. */
 	if (snd_cnt != rec_cnt) {
@@ -475,13 +603,35 @@
 		cmp = rec_cnt ? strcmp(snd_rxa->name, rec_rxa->name) : -1;
 		if (cmp > 0)
 			same = 0;
-		else if (snd_rxa->datum_len > MAX_FULL_DATUM) {
+		else if (snd_rxa->datum_len == 1 && snd_rxa->datum[0] == XSTATE_DECMPFS) { // TODO: had (have?) a SIGBUS crash here, added "snd_rxa->datum_len == 1 && "
+			// If we've gotten this far, we're going to assume the xattrs are different 
+			// because the files are different in size, mod date, or flags
+			same = 0;
+
+			if (verbose)
+				fprintf(stderr, "DEBUG: xattr_diff[TODO]: name: %s |%s\n", snd_rxa->name, f_name(file, NULL));
+
+			snd_rxa->datum[0] = XSTATE_TODO;
+		} else if (snd_rxa->datum_len > MAX_FULL_DATUM) {
 			same = cmp == 0 && snd_rxa->datum_len == rec_rxa->datum_len
 			    && memcmp(snd_rxa->datum + 1, rec_rxa->datum + 1,
 				      MAX_DIGEST_LEN) == 0;
+#ifdef FAST_RESOURCE_FORKS
+			if (same && strcmp(snd_rxa->name, XATTR_RESOURCEFORK_NAME) == 0)
+				same = cmp_time(sxp->st.st_mtime, file->modtime) == 0;
+#endif
+
 			/* Flag unrequested items that we need. */
-			if (!same && find_all && snd_rxa->datum[0] == XSTATE_ABBREV)
+			if (!same && find_all && snd_rxa->datum[0] == XSTATE_ABBREV) {
 				snd_rxa->datum[0] = XSTATE_TODO;
+				if (verbose)
+					fprintf(stderr, "DEBUG: xattr_diff[TODO]: name: %s |%s\n", snd_rxa->name, f_name(file, NULL));
+			} else {
+				// The item remains abbreviated, rsync_xal_set will retrieve this value from the local file that's getting replaced
+				stats.total_unchanged_size += snd_rxa->datum_len; // Only add abbreviated xattrs here to match sender behavior
+				if (verbose > 1)
+					fprintf(stderr, "xattr_diff: stats.total_unchanged_size += %lu = %llu (%s)\n", (unsigned long)snd_rxa->datum_len, stats.total_unchanged_size, f_name(file, NULL));
+			}
 		} else {
 			same = cmp == 0 && snd_rxa->datum_len == rec_rxa->datum_len
 			    && memcmp(snd_rxa->datum, rec_rxa->datum,
@@ -522,14 +672,30 @@
 
 	lst += F_XATTR(file);
 	for (rxa = lst->items, cnt = lst->count; cnt--; rxa++) {
-		if (rxa->datum_len <= MAX_FULL_DATUM)
+		if (verbose)
+			fprintf(stderr, "DEBUG: send_x_request: name: %s, type: %d, len: %lu, fl: %#x%s, ndx: %d |%s\n", rxa->name, rxa->datum[0], (unsigned long)rxa->datum_len, F_FFLAGS(file), !(rxa->datum_len <= MAX_FULL_DATUM && !(preserve_hfs_compression && F_FFLAGS(file) & UF_COMPRESSED)) ? "" : am_generator ? " [Have datum]" : " [No send]", F_XATTR(file), (fname != NULL ? full_fname(fname) : "gen"));
+
+		// For decmpfs xattrs, we artificially set the datum_length to 1 and treat it like an abbreviated xattr. The datum_length is 1 because
+		// we don't calculate a checksum of these xattrs, nor even read them on the source in flist, so we have nothing to put into datum
+		// As a result, we need a special case here to not continue if datum_len is < MAX_FULL_DATUM but the xattr is a decmpfs xattr
+
+		// This has to be errant. If (rxa->datum_len <= MAX_FULL_DATUM), I can't count on the first byte of datum to be an XATTR type flag
+		// What if the UF_COMPRESSED flag is errantly set on a file?
+		// I need to prove that it's possible to have that flag errantly and reproduce this.
+		// TODO: Could it be that the fileflags on disk are correct, but we're somehow not initiating the fileflags correctly in flist?
+		int xattrIsDecmpfsXattr = strcmp(rxa->name, XATTR_DECMPFS_NAME) == 0 || strcmp(rxa->name, XATTR_RESOURCEFORK_NAME) == 0;
+		if (rxa->datum_len <= MAX_FULL_DATUM && !(preserve_hfs_compression && F_FFLAGS(file) & UF_COMPRESSED && xattrIsDecmpfsXattr))
+		//if (rxa->datum_len <= MAX_FULL_DATUM && !(preserve_hfs_compression && strcmp(rxa->name, XATTR_DECMPFS_NAME) == 0)) // Does this accommodate the resource fork case?
+		//if (rxa->datum_len <= MAX_FULL_DATUM && !(preserve_hfs_compression && strcmp(rxa->name, "com.apple.quarantine") == 0)) // DEBUG
 			continue;
 		switch (rxa->datum[0]) {
+		case XSTATE_DECMPFS:
 		case XSTATE_ABBREV:
 			/* Items left abbreviated matched the sender's checksum, so
 			 * the receiver will cache the local data for future use. */
 			if (am_generator)
 				rxa->datum[0] = XSTATE_DONE;
+
 			continue;
 		case XSTATE_TODO:
 			assert(f_out >= 0);
@@ -538,6 +704,9 @@
 			continue;
 		}
 
+		if (verbose)
+			fprintf(stderr, "DEBUG: send_x_request[%s]: Sending %sabbrev xattr: name: %s, type: %d, len: %lu, rxa->num: %d, prior_req: %d, ndx: %d\n", who_am_i(), am_generator ? "request for " : "", rxa->name, rxa->datum[0], rxa->datum_len, rxa->num, prior_req, F_XATTR(file));
+
 		/* Flag that we handled this abbreviated item. */
 		rxa->datum[0] = XSTATE_DONE;
 
@@ -550,7 +719,8 @@
 
 			/* Re-read the long datum. */
 			if (!(ptr = get_xattr_data(fname, rxa->name, &len, 0))) {
-				rprintf(FERROR_XFER, "failed to re-read xattr %s for %s\n", rxa->name, fname);
+				if (errno != ENOTSUP && errno != ENOATTR)
+					rprintf(FERROR_XFER, "failed to re-read xattr %s for %s\n", rxa->name, full_fname(fname));
 				write_varint(f_out, 0);
 				continue;
 			}
@@ -558,6 +728,27 @@
 			write_varint(f_out, len); /* length might have changed! */
 			write_buf(f_out, ptr, len);
 			free(ptr);
+
+			// Update stats on sender side
+#if 0
+			// Non-Finder math method:
+			if (strcmp(rxa->name, XATTR_DECMPFS_NAME) == 0 || (preserve_hfs_compression && F_FFLAGS(file) & UF_COMPRESSED && strcmp(rxa->name, XATTR_RESOURCEFORK_NAME) == 0)) {
+				stats.total_size += len;
+				if (verbose > 1)
+					fprintf(stderr, "DEBUG: [%s] SENDXA: stats.total_size |%s|+%lu|%s|\n", who_am_i(), full_fname(fname), (unsigned long)len, rxa->name);
+			}
+			stats.total_transferred_size += len;
+			if (verbose > 1)
+				fprintf(stderr, "DEBUG: [%s] SENDXA: stats.total_transferred_size |%s|+%lu|%s|\n", who_am_i(), full_fname(fname), (unsigned long)len, rxa->name);
+			stats.xattr_transfer_size += len;
+#else
+			if (!(preserve_hfs_compression && F_FFLAGS(file) & UF_COMPRESSED)) {
+				stats.total_transferred_size += len;
+				if (verbose > 1)
+					fprintf(stderr, "DEBUG: [%s] SENDXA: stats.total_transferred_size |%s|+%lu|%s|\n", who_am_i(), full_fname(fname), (unsigned long)len, rxa->name);
+			}
+			stats.xattr_transfer_size += len;
+#endif
 		}
 	}
 
@@ -585,23 +776,32 @@
 	cnt = lst->count;
 	rxa = lst->items;
 	num = 0;
+
 	while ((rel_pos = read_varint(f_in)) != 0) {
 		num += rel_pos;
+		if (verbose)
+			//if (am_sender || am_generator)
+			fprintf(stderr, "DEBUG: recv_x_request[%s]: abbrev req, rel_pos: %d, ndx: %d |%s\n", who_am_i(), rel_pos, F_XATTR(file), f_name(file, NULL));
 		while (cnt && rxa->num < num) {
 		    rxa++;
 		    cnt--;
 		}
 		if (!cnt || rxa->num != num) {
 			rprintf(FERROR, "[%s] could not find xattr #%d for %s\n",
-				who_am_i(), num, f_name(file, NULL));
+				who_am_i(), num, full_fname(f_name(file, NULL)));
+			// This next line will cause a crash if rxa->name is corrupted
+			fprintf(stderr, "DEBUG: cnt: %d, name: %s, rxa->num: %d (%s)\n", cnt, rxa->name, rxa->num, full_fname(f_name(file, NULL)));
 			exit_cleanup(RERR_STREAMIO);
 		}
-		if (!XATTR_ABBREV(*rxa) || rxa->datum[0] != XSTATE_ABBREV) {
-			rprintf(FERROR, "[%s] internal abbrev error on %s (%s, len=%ld)!\n",
-				who_am_i(), f_name(file, NULL), rxa->name, (long)rxa->datum_len);
+		if ((!XATTR_ABBREV(*rxa) || rxa->datum[0] != XSTATE_ABBREV) && rxa->datum[0] != XSTATE_DECMPFS) {
+			rprintf(FERROR, "[%s] internal abbrev error on %s (%s, len=%ld, datum[0]: %d)!\n",
+				who_am_i(), full_fname(f_name(file, NULL)), rxa->name, (long)rxa->datum_len, rxa->datum[0]);
 			exit_cleanup(RERR_STREAMIO);
 		}
 
+		if (am_sender && verbose)
+			fprintf(stderr, "DEBUG: recv_x_request[snd]: %s: type: %d, rel_pos: %d, ndx: %d\n", rxa->name, rxa->datum[0], rel_pos, F_XATTR(file));
+		
 		if (am_sender) {
 			rxa->datum[0] = XSTATE_TODO;
 			continue;
@@ -609,6 +809,9 @@
 
 		old_datum = rxa->datum;
 		rxa->datum_len = read_varint(f_in);
+		
+		if (verbose > 1)
+			fprintf(stderr, "\t%s: datum_length is %lu\n", rxa->name, (unsigned long)rxa->datum_len);
 
 		if (rxa->name_len + rxa->datum_len < rxa->name_len)
 			overflow_exit("recv_xattr_request");
@@ -621,6 +824,14 @@
 		free(old_datum);
 		read_buf(f_in, rxa->datum, rxa->datum_len);
 		got_xattr_data = 1;
+
+		// We get 0-sized files on the receiver end for compressed file, but the sender tracks uncompressed size. Only for the purpose of progress indication, we fudge the tts value here so it can attempt to keep up with the total_size value presented by the sender.
+		//if (rxa->datum[0] != XSTATE_DECMPFS) {
+			stats.total_transferred_size += rxa->datum_len;
+			if (verbose > 1)
+				fprintf(stderr, "DEBUG: [%s] RECVXA: stats.total_transferred_size += %lu = %llu (%s)\n", who_am_i(), (unsigned long)rxa->datum_len, stats.total_transferred_size, f_name(file, NULL));
+		//}
+		stats.xattr_transfer_size += rxa->datum_len;
 	}
 
 	return got_xattr_data;
@@ -642,7 +853,7 @@
 
 	if (ndx < 0 || (size_t)ndx > rsync_xal_l.count) {
 		rprintf(FERROR, "receive_xattr: xa index %d out of"
-			" range for %s\n", ndx, f_name(file, NULL));
+			" range for %s\n", ndx, full_fname(f_name(file, NULL)));
 		exit_cleanup(RERR_STREAMIO);
 	}
 
@@ -656,6 +867,10 @@
 		temp_xattr.count = 0;
 	}
 
+	if (verbose)
+		// xal_cnt should always be xndx+1
+		fprintf(stderr, "DEBUG: receive_xattr[%s]: cnt: %d, ndx: %ld |%s\n", who_am_i(), count, rsync_xal_l.count, f_name(file, NULL));
+
 	for (num = 1; num <= count; num++) {
 		char *ptr, *name;
 		rsync_xa *rxa;
@@ -664,7 +879,7 @@
 		size_t dget_len = datum_len > MAX_FULL_DATUM ? 1 + MAX_DIGEST_LEN : datum_len;
 		size_t extra_len = MIGHT_NEED_RPRE ? RPRE_LEN : 0;
 		if ((dget_len + extra_len < dget_len)
-		 || (dget_len + extra_len + name_len < dget_len))
+		 || (dget_len + extra_len + name_len < dget_len + extra_len))
 			overflow_exit("receive_xattr");
 		ptr = new_array(char, dget_len + extra_len + name_len);
 		if (!ptr)
@@ -677,6 +892,8 @@
 			*ptr = XSTATE_ABBREV;
 			read_buf(f, ptr + 1, MAX_DIGEST_LEN);
 		}
+		if (verbose)
+			fprintf(stderr, "DEBUG: receive_xattr, name: %s, type: %s(%d), len: %lu, num: %d\n", name, dget_len == datum_len ? "reg" : "abbrev", ptr[0], (unsigned long)datum_len, num);
 #ifdef HAVE_LINUX_XATTRS
 		/* Non-root can only save the user namespace. */
 		if (am_root <= 0 && !HAS_PREFIX(name, USER_PREFIX)) {
@@ -711,12 +928,15 @@
 			free(ptr);
 			continue;
 		}
+		
 		rxa = EXPAND_ITEM_LIST(&temp_xattr, rsync_xa, 1);
 		rxa->name = name;
 		rxa->datum = ptr;
 		rxa->name_len = name_len;
 		rxa->datum_len = datum_len;
 		rxa->num = num;
+
+		stats.num_xattrs++;
 	}
 
 	if (need_sort && count > 1)
@@ -725,6 +945,12 @@
 	ndx = rsync_xal_l.count; /* pre-incremented count */
 	rsync_xal_store(&temp_xattr); /* adds item to rsync_xal_l */
 
+	// If we call cache_tmp_xattr(), and then fail to call uncache_tmp_xattrs(), rsync_xal_l.count will not be the correct index value
+	// TODO: We should instead set ndx to rsync_xal_l.count - 1 after adding this file's xattr to the list
+	if (verbose && ndx == rsync_xal_l.count)
+		// xal_cnt should always be xndx+1
+		fprintf(stderr, "DEBUG: receive_xattr[%s]: rsync_xal_l.count was not incremented!\n", who_am_i());
+	//ndx = rsync_xal_l.count - 1;
 	F_XATTR(file) = ndx;
 }
 
@@ -739,9 +965,16 @@
 
 	if (prior_xattr_count == (size_t)-1)
 		prior_xattr_count = rsync_xal_l.count;
-	ndx = find_matching_xattr(sxp->xattr);
-	if (ndx < 0)
-		rsync_xal_store(sxp->xattr); /* adds item to rsync_xal_l */
+	
+	// find_matching_xattr is a waste of cycles for MOSX clients
+	//ndx = find_matching_xattr(sxp->xattr);
+	ndx = -1;
+	if (ndx < 0) {
+		if (verbose)
+			fprintf(stderr, "DEBUG: cache_tmp_xattr[%s]: Adding a tmp xattr, ndx: %ld\n", who_am_i(), rsync_xal_l.count);
+		rsync_xal_store(sxp->xattr); /* adds item to rsync_xal_l */ // sxp->xattr->count is 0 coming out of rsync_xal_store
+		//ndx = rsync_xal_l.count - 1; // Right?
+	}
 
 	F_XATTR(file) = ndx;
 }
@@ -752,10 +985,12 @@
 		item_list *xattr_item = rsync_xal_l.items;
 		item_list *xattr_start = xattr_item + prior_xattr_count;
 		xattr_item += rsync_xal_l.count;
+		if (verbose)
+			fprintf(stderr, "DEBUG: uncache_tmp_xattrs[%s]: Removing %ld items from the end of rsync_xal_l. New count: %ld\n", who_am_i(), rsync_xal_l.count - prior_xattr_count, prior_xattr_count);
 		rsync_xal_l.count = prior_xattr_count;
 		while (xattr_item-- > xattr_start) {
 			rsync_xal_free(xattr_item);
-			free(xattr_item);
+			free(xattr_item->items);
 		}
 		prior_xattr_count = (size_t)-1;
 	}
@@ -774,6 +1009,12 @@
 	size_t name_len;
 	int ret = 0;
 
+//	struct timeval start;
+//	gettimeofday(&start, NULL);
+
+	if (verbose > 1)
+		fprintf(stderr, "DEBUG: rsync_xal_set(%s): fname: %s, fnamecmp: %s\n", who_am_i(), fname, fnamecmp);
+
 	/* This puts the current name list into the "namebuf" buffer. */
 	if ((list_len = get_xattr_names(fname)) < 0)
 		return -1;
@@ -781,41 +1022,70 @@
 	for (i = 0; i < xalp->count; i++) {
 		name = rxas[i].name;
 
+		if (verbose > 1)
+			fprintf(stderr, "\t%s: datum_type: %d, datum_len: %lu\n", name, rxas[i].datum[0], (unsigned long)rxas[i].datum_len);
+		
 		if (XATTR_ABBREV(rxas[i])) {
 			/* See if the fnamecmp version is identical. */
 			len = name_len = rxas[i].name_len;
+			if (verbose > 1)
+				fprintf(stderr, "Calling get_xattr_data(%s, %s, &len, 1), am_generator: %d\n", fnamecmp, name, am_generator);
 			if ((ptr = get_xattr_data(fnamecmp, name, &len, 1)) == NULL) {
 			  still_abbrev:
 				if (am_generator)
 					continue;
-				rprintf(FERROR, "Missing abbreviated xattr value, %s, for %s\n",
-					rxas[i].name, full_fname(fname));
+				rprintf(FERROR, "Missing abbreviated xattr value, %s, for %s [%d/%lu/%lu]\n",
+					rxas[i].name, full_fname(fname), errno, (unsigned long)rxas[i].datum_len, (unsigned long)len);
 				ret = -1;
 				continue;
 			}
-			if (len != rxas[i].datum_len) {
+			
+			if (verbose > 1)
+				fprintf(stderr, "\t%s: datum_len: %lu, expected datum_len: %lu\n", name, (unsigned long)len, (unsigned long)rxas[i].datum_len);
+			
+			if (len != rxas[i].datum_len && rxas[i].datum[0] != XSTATE_DECMPFS) { // We expect the length to not match with decmpfs xattrs
 				free(ptr);
 				goto still_abbrev;
 			}
 
-			sum_init(checksum_seed);
-			sum_update(ptr, len);
-			sum_end(sum);
-			if (memcmp(sum, rxas[i].datum + 1, MAX_DIGEST_LEN) != 0) {
-				free(ptr);
-				goto still_abbrev;
+			if (!(preserve_hfs_compression && sxp->st.st_flags & UF_COMPRESSED)) {
+#ifdef FAST_RESOURCE_FORKS
+				if (strcmp(name, XATTR_RESOURCEFORK_NAME) == 0) {
+					memcpy(&sum, ptr, MAX_DIGEST_LEN);
+					if (verbose > 1)
+						fprintf(stderr, "\t%s: \"sum\" is %s\n", name, sum);
+				} else {
+#endif
+				if (verbose > 1)
+					fprintf(stderr, "xal_get(%s): Calculating a checksum for %s xattr\n", who_am_i(), name);
+				sum_init(checksum_seed);
+				sum_update(ptr, len);
+				sum_end(sum);
+#ifdef FAST_RESOURCE_FORKS
+				}
+#endif
+				if (memcmp(sum, rxas[i].datum + 1, MAX_DIGEST_LEN) != 0) {
+					free(ptr);
+					goto still_abbrev;
+				}
 			}
-
+			
 			if (fname == fnamecmp)
 				; /* Value is already set when identical */
 			else if (sys_lsetxattr(fname, name, ptr, len) < 0) {
-				rsyserr(FERROR_XFER, errno,
-					"rsync_xal_set: lsetxattr(\"%s\",\"%s\") failed",
-					fname, name);
+				if (strcmp(name, KAUTH_FILESEC_XATTR) != 0 && len > 0) {
+					if (strcmp(name, XATTR_RESOURCEFORK_NAME) == 0 && len > pc_xattr_max_size)
+						errno = E2BIG;
+					rsyserr(FERROR_XFER, errno,
+						"rsync_xal_set: lsetxattr(%s,\"%s\",\"%lu\") failed",
+						full_fname(fname), name, (unsigned long)len);
+				}
 				ret = -1;
-			} else /* make sure caller sets mtime */
+			} else {/* make sure caller sets mtime */
+				if (verbose > 1)
+					fprintf(stderr, "\t%s: Called sys_lsetxattr on %s\n", name, full_fname(fname));
 				sxp->st.st_mtime = (time_t)-1;
-
+			}
 			if (am_generator) { /* generator items stay abbreviated */
 				free(ptr);
 				continue;
@@ -828,14 +1098,22 @@
 			rxas[i].datum = ptr;
 			continue;
 		}
-
-		if (sys_lsetxattr(fname, name, rxas[i].datum, rxas[i].datum_len) < 0) {
-			rsyserr(FERROR_XFER, errno,
-				"rsync_xal_set: lsetxattr(\"%s\",\"%s\") failed",
-				fname, name);
+		
+		int result = sys_lsetxattr(fname, name, rxas[i].datum, rxas[i].datum_len);
+		if (result < 0) {
+			if (((receiver_uid == 0 || receiver_uid == sxp->st.st_uid) && strcmp(name, KAUTH_FILESEC_XATTR) != 0 && rxas[i].datum_len > 0) || (errno != EPERM && errno != EACCES)) {
+				if (strcmp(name, XATTR_RESOURCEFORK_NAME) == 0 && len > pc_xattr_max_size)
+					errno = E2BIG;
+				rsyserr(FERROR_XFER, errno,
+					"rsync_xal_set: lsetxattr(%s,\"%s\",\"%lu\") failed",
+					full_fname(fname), name, (unsigned long)rxas[i].datum_len);
+			}
 			ret = -1;
-		} else /* make sure caller sets mtime */
+		} else /* make sure caller sets mtime */ {
+			if (verbose > 1)
+				fprintf(stderr, "\trsync_xal_set: sys_lsetxattr(%s, %s, [datum_buf], %lu) returned %d (%d)\n", fname, name, (unsigned long)rxas[i].datum_len, result, errno);
 			sxp->st.st_mtime = (time_t)-1;
+		}
 	}
 
 	/* Remove any extraneous names. */
